<?php
session_start();
if(!isset($_SESSION['username']) or $_SESSION['username'] != "admin") die("Access restricted");

require_once('config.php');
$masterdb = new GenericSqliteTable("var/master.db","master");
$areadb = new GenericSqliteTable("var/area.db","area");

$adminHashedPassword = GetConfigOption('adminHashedPassword');

if (isset($_FILES["file"]))
if ($_FILES["file"]["error"] > 0)
{
	//echo "Error: " . $_FILES["file"]["error"] . "<br />";
}
else
{
	//echo "Upload: " . $_FILES["file"]["name"] . "<br />";
	//echo "Type: " . $_FILES["file"]["type"] . "<br />";
	//echo "Size: " . ($_FILES["file"]["size"] / 1024) . " Kb<br />";
	//echo "Stored in: " . $_FILES["file"]["tmp_name"];
	move_uploaded_file($_FILES["file"]["tmp_name"], GetConfigOption('uploadDatabaseName'));
}

if(isset($_POST['nukedatabase']) and $_POST['nukedatabase'] == "CONFIRM")
{
	if(file_exists(GetConfigOption('uploadDatabaseName'))) unlink(GetConfigOption('uploadDatabaseName'));
	$masterdb->Purge();
}

//Validate Import options
$importError = Null;
if(isset($_POST['importname']) and isset($_POST['importref']))
{
	$fi = fopen(GetConfigOption('uploadDatabaseName'),"rt");
	$colNames = fgetcsv($fi);

	if(!in_array($_POST['importname'],$colNames))
		$importError = "Unknown column ".$_POST['importname'];
	if(!in_array($_POST['importref'],$colNames))
		$importError = "Unknown column ".$_POST['importref'];

	//Validate reference column
	$refs = array();
	if($importError == Null)
	do
	{
		$row = fgetcsv($fi);
		if($row === FALSE) continue;
		$data = array_combine($colNames,$row);
		//print_r($data);
		$ref = $data[$_POST['importref']];
		if(in_array($ref, $refs)) $importError = "Duplicate ID detected in selected column ".$_POST['importref'];
		array_push($refs,$ref);
		//print_r($refs);
	} while($row !== FALSE);
}

//Do import from CSV to SQLite
$recordsImported = Null;
$lineCount = 0;
if(isset($_POST['importname']) and isset($_POST['importref']) and $importError == Null)
{
$fi = fopen(GetConfigOption('uploadDatabaseName'),"rt");

do
{
	$line = fgetcsv($fi);
	if($line === FALSE) continue;
	//print_r($line);
	
	//Get the column names from the first line
	if($lineCount == 0)
	{
		$colNames = $line;
		$lineCount ++;
		continue;
	}

	$record = array_combine($colNames, $line);
	//print_r($record);
	$id = $record[$_POST['importref']];
	$masterdb[$id] = $record;
	if($recordsImported==Null) $recordsImported = 0;
	$recordsImported ++;
	//echo "Updated ".$id."<br>\n";
	//print_r($record);

	//Set area
/*	$area = $record[$areaCode];
	if(strlen(rtrim($area))==0) $area = "None";
	if(isset($areadb[$area]))
		$recordsInArea = $areadb[$area];
	else $recordsInArea = array();
	if(!in_array($id,$recordsInArea)) array_push($recordsInArea, $id);
	$areadb[$area] = $recordsInArea;
*/
	

	$lineCount ++;
} while($line !== FALSE);

SetConfigOption('nameCol',$_POST['importname']);

}

//Get list of record ids
$masterIds = $masterdb->GetKeys();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by Free CSS Templates
http://www.freecsstemplates.org
Released for free under a Creative Commons Attribution 2.5 License

Name       : Tomatoes
Description: A two-column, fixed-width design for 1024x768 screen resolutions.
Version    : 1.0
Released   : 20110301

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?php echo GetConfigOption('overallTitle').", ".GetConfigOption('subTitle');?></title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="wrapper">
	<div id="header">
		<div id="menu">
			<ul>
				<?php $pageCatExplore = 1;
				require('topbar.php'); ?>
			</ul>
		</div>
		<!-- end #menu -->
	</div>
	<div id="logo">
		<h1><a href="#"><?php echo GetConfigOption('overallTitle');?></a></h1>
		<p><em><?php echo GetConfigOption('subTitle');?></em></p>
	</div>
	<hr />
	<!-- end #logo -->
	<div id="page">
		<div id="page-bgtop">
			<div id="content">

<?php
if($recordsImported!=Null)
{
?>
				<div class="post">
					<h2 class="title"><a href="#"><?php echo $recordsImported;?> Records Imported</a></h2>
					<div class="entry">

					</div>
				</div>


<?php
}


if($importError!=Null)
{
?>
				<div class="post">
					<h2 class="title"><a href="#"><?php echo htmlspecialchars($importError);?></a></h2>
					<div class="entry">
					<p>Import Failed</p>
					</div>
				</div>


<?php
}


if(!file_exists(GetConfigOption('uploadDatabaseName')))
{
?>
				<div class="post">
					<h2 class="title"><a href="#">Import Dataset</a></h2>
					<div class="entry">
						<p>The uploaded file must meet a few requirements:</p>
						<ul><li>It must be <a href="http://en.wikipedia.org/wiki/Comma-separated_values">CSV formatted</a></li>
						<li>The separator character must be a comma. Sometimes semi-colons are seen in CSV files but this will not work.</li>
						<li>The first row must be the column names.</li>
						<li>The rows (other than the first column) represent a single record</li>
						<li>At least one column must contain a unique ID for each row.</li>
						<li>At least one column must contain a human readable name of the record (typically the name of the service to be located). In Calc, you may need to go to "File", "Save as..." and enable "edit filter settings".</li>
						</ul>
						<p>CSV files can the created and read using OpenOffice/LibreOffice Calc or Microsoft Excel.</p>
						<form action="" method="post" enctype="multipart/form-data">
						<p>Filename:<input type="file" name="file" id="file" /></p>
						<p><input type="submit" name="submit" value="Submit" /></p>
						</form>
					</div>
				</div>
<?php
}
?>

<?php
if(file_exists(GetConfigOption('uploadDatabaseName')) and !count($masterIds)>0)
{

	$fi = fopen(GetConfigOption('uploadDatabaseName'),"rt");
	$colNames = fgetcsv($fi);
?>
				<div class="post">
					<h2 class="title"><a href="#">Convert CSV to Internal Format</a></h2>
					<div class="entry"><form method="post" action="">
					<p>Human Readable Name: <select name="importname">
					<?php
					foreach($colNames as $col) echo "<option>".htmlspecialchars($col)."</option>\n";
					?>
					</select> - this should be the column containing the name familiar to the general public. This can be changed later.</p>
					<p>ID Reference: <select name="importref">
					<?php
					foreach($colNames as $col) echo "<option>".htmlspecialchars($col)."</option>\n";
					?>
					</select> - this should be the column containing a unique ID for each row. This <em>cannot</em> be changed later.</p>
					<p><input type="submit" value="Submit" /></p>
					</form></div>
				</div>
<?php
}

if(count($masterIds)>0)
{
?>
				<div class="post">
					<h2 class="title"><a href="#">Data Ready For Use</a></h2>

					<div class="entry">

					<p>Remember to <a href="roughposition.php">set</a> initial positions each point!</p>
					</div>
				</div>


<?php
}
?>
				<div class="post">
					<h2 class="title"><a href="#">Clear Imported Data</a></h2>

					<div class="entry"><form action="" method="post">

					<p>Type CONFIRM and press Submit: <input type="text" name="nukedatabase" value=""/></p>
					<p><input type="submit" value="Submit" /></p>
					</form></div>
				</div>


			</div>
			<!-- end #content -->
			<div id="sidebar">
				<ul>
					<?php require('sidebar.php'); ?>

				</ul>
			</div>
			<!-- end #sidebar -->
			<div style="clear: both;">&nbsp;</div>
		</div>
	</div>
	<!-- end #page -->
	<div id="footer">

<?php
echo GetConfigOption('footer');
?>
	</div>
	<!-- end #footer -->
</div>
</body>
</html>
