<?php
session_start();
require_once('config.php');
require_once('dbutils.php');
require_once('locationfuncs.php');
require_once('externaldbfuncs.php');

$masterdb = new GenericSqliteTable("var/master.db","master");
$nameCol = GetConfigOption('nameCol');

if(GetConfigOption('enableArea'))
{
	if(isset($_GET['area'])) $_SESSION['area'] = $_GET['area'];
	if(!isset($_GET['area']) and isset($_SESSION['area'])) $_GET['area'] = $_SESSION['area'];
	if(!isset($_GET['area'])) $_GET['area'] = $listAreas[0];
	$ids = $areadb[$_GET['area']];
}
else
{
	$ids = $masterdb->GetKeys();
}


//Find marker locations and external links
$bestlocs = array();
$bestosm = array();
$markercol = array();
$minlat = Null; $maxlat = Null; $minlon = Null; $maxlon = Null;
foreach($ids as $id)
{
	$ret = GetBestLocation($id);
	$bestlocs[$id] = $ret;
	$ret = GetBestOsmLink($id);
	$bestosm[$id] = $ret;
	//print_r($bestlocs[$id]);

	//Determine marker status
	$located = 0;
	$presentOsm = 0;
	if($bestlocs[$id][0] != Null and !$bestlocs[$id][1])
		$located = 1;
	if(!$located and $bestosm[$id][0] != Null)
		$presentOsm = 1;

	//Assign colour
	$markercol[$id] = "red";
	if($presentOsm) $markercol[$id] = "yellow";
	if($located) $markercol[$id] = "green";

	//Update bounding box
	if($bestlocs[$id][0]!==null)
	{
		$lat = $bestlocs[$id][0][0]; $lon = $bestlocs[$id][0][1];
		if(is_null($minlat) or $minlat > $lat) $minlat = $lat;
		if(is_null($maxlat) or $maxlat < $lat) $maxlat = $lat;
		if(is_null($minlon) or $minlon > $lon) $minlon = $lon;
		if(is_null($maxlon) or $maxlon < $lon) $maxlon = $lon;
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by Free CSS Templates
http://www.freecsstemplates.org
Released for free under a Creative Commons Attribution 2.5 License

Name       : Tomatoes
Description: A two-column, fixed-width design for 1024x768 screen resolutions.
Version    : 1.0
Released   : 20110301

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?php echo GetConfigOption('overallTitle').", ".GetConfigOption('subTitle');?></title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="wrapper">
	<div id="header">
		<div id="menu">
			<ul>
				<?php $pageCatList = 1;
				require('topbar.php'); ?>
			</ul>
		</div>
		<!-- end #menu -->
	</div>
	<div id="logo">
		<h1><a href="#"><?php echo GetConfigOption('overallTitle');?></a></h1>
		<p><em><?php echo GetConfigOption('subTitle');?></em></p>
	</div>
	<hr />
	<!-- end #logo -->
	<div id="page">
		<div id="page-bgtop">
			<div id="content">
				<div class="post">
					<h2 class="title"><a href="#">List of all POIs<?php if(isset($_GET['area'])) echo " in ".$_GET['area']; ?></a></h2>
					<div class="entry">
<?php
//*****************************
//Generate Textual List of POIs
//*****************************

//print_r($ids);

echo "<ul>\n";

foreach($ids as $ind => $id)
{
	if($ind == "key") continue; //Avoid a quirk of generic sqlite class :)
	$record = $masterdb[$id];
	echo "<li>";
	//echo $id;
	echo "<img src=\"img/button-".$markercol[$id].".png\" height='16px' width='16px' alt=\"".$markercol[$id]." button\" />";	
	echo " <a href=\"details.php?id=".htmlspecialchars($id)."\">".htmlspecialchars($record[$nameCol]);
	echo "</a>";
	if($bestosm[$id][0]!=null)
	{
		echo " <a href=\"http://www.openstreetmap.org/browse/".htmlspecialchars($bestosm[$id][0])."/".$bestosm[$id][1]."\"><img src=\"img/link.png\" alt=\"Link image\" height='16px' width='16px'/></a>\n";
	}
	//print_r(GetBestLocation($id));
	//print_r(GetBestOsmLink($id));
	echo "</li>\n";
	
}

echo "</ul>\n";
?>
					</div>
				</div>

			</div>
			<!-- end #content -->
			<div id="sidebar">
				<ul>
					<?php require('sidebar.php'); ?>

				</ul>
			</div>
			<!-- end #sidebar -->
			<div style="clear: both;">&nbsp;</div>
		</div>
	</div>
	<!-- end #page -->
	<div id="footer">

<?php
echo GetConfigOption('footer');
?>
	</div>
	<!-- end #footer -->
</div>
</body>
</html>
