<?php
session_start();
require_once('config.php');
require_once('dbutils.php');
require_once('locationfuncs.php');
require_once('activity.php');
$masterdb = new GenericSqliteTable("var/master.db","master");
$locationdb = new GenericSqliteTable("var/locations.db","locations");
$basemap = "sv";
if(isset($_GET['basemap'])) $basemap = $_GET['basemap'];
$nameCol = GetConfigOption('nameCol');
?>

<?php
if(!isset($masterdb[$_GET['id']]))
	die("No such ID");

$record = $masterdb[$_GET['id']];
$locations = $locationdb[$_GET['id']];
$initialLoc = GetBestLocation($_GET['id']);
$initialZoom = GetConfigOption('initialZoomMarking');
if($initialLoc[0] == null)
{
	//If no initial position is set, zoom out to entire world
	$initialLoc[0] = array();
	$initialLoc[0][0] = 0.;
	$initialLoc[0][1] = 0.;
	$initialZoom = 1;
}

//Add some noise to initial location to avoid direct copying from one dataset to another
$noise = GetConfigOption('markPageNoise');
if($noise === Null) $noise = 0.;
$initialLoc[0][0] += $noise * ((float)(mt_rand(0,2000)-1000)/1000.0);
$initialLoc[0][1] += $noise * ((float)(mt_rand(0,2000)-1000)/1000.0);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by Free CSS Templates
http://www.freecsstemplates.org
Released for free under a Creative Commons Attribution 2.5 License

Name       : Tomatoes
Description: A two-column, fixed-width design for 1024x768 screen resolutions.
Version    : 1.0
Released   : 20110301

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?php echo GetConfigOption('overallTitle').", ".GetConfigOption('subTitle').", ".$record[$nameCol];?></title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
	<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
	<script type="text/javascript" src="googlemap.js"></script>
<link href="atomfeed.php" type="application/atom+xml" rel="alternate" title="Sitewide ATOM Feed" />
</head>
<body onload="createMapAndMarker(<?php echo $initialLoc[0][0].','.$initialLoc[0][1].','.$initialZoom; ?>,'<?php echo $basemap;?>')">
<div id="wrapper">
	<div id="header">
		<div id="menu">
			<ul>
				<?php $pageCatExplore = 1;
				require('topbar.php'); ?>
			</ul>
		</div>
		<!-- end #menu -->
	</div>
	<div id="logo">
		<h1><a href="#"><?php echo GetConfigOption('overallTitle');?></a></h1>
		<p><em><?php echo GetConfigOption('subTitle');?></em></p>
	</div>
	<hr />
	<!-- end #logo -->
	<div id="page">
		<div id="page-bgtop">
			<div id="content">

<?php

//*****************
//Process Comment
//*****************
$captchaFailed = 0;
if(isset($_POST['lat']) and !GetConfigOption('readOnly'))
{
	if(GetConfigOption('enableCaptcha'))
	{	
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$privatekey = GetConfigOption('recaptchaPrivate');
	$resp = recaptcha_check_answer ($privatekey,
	                       $_SERVER["REMOTE_ADDR"],
	                       $_POST["recaptcha_challenge_field"],
	                       $_POST["recaptcha_response_field"]);

	if (!$resp->is_valid) {
	  // What happens when the CAPTCHA was entered incorrectly
	  $captchaFailed = 1;
	}
	}

	if(!$captchaFailed)
	{
	//print_r($_POST);
	$newloc = array();
	$newloc['comment'] = substr($_POST['comment'],0,$maxchars);
	$newloc['nickname'] = substr($_POST['nickname'],0,$maxnickname);
	$newloc['lat'] = (float)($_POST['lat']);
	$newloc['lon'] = (float)($_POST['lon']);
	$newloc['timestamp'] = time();
	$newloc['source'] = "unknown traced location";
	$newloc['license'] = "unspecified";

	if($_POST['layer']=="osm")
	{
		$newloc['source'] = "Open Steet Map location";
		$newloc['license'] = "CC by-SA";
	}
	if($_POST['layer']=="sv")
	{
		$newloc['source'] = "OS OpenData location";
		$newloc['license'] = "OS OpenData/OGL";
	}
	if($_POST['layer']=="os7")
	{
		$newloc['source'] = "7th Series OS location";
		$newloc['license'] = "CC0";
	}

	if($_POST['layer']=="npe")
	{
		$newloc['source'] = "New Popular Edition location";
		$newloc['license'] = "CC0";
	}

	$newloc['roughposition'] = false;
	$newloc['karma'] = 1;
	$newloc['uuid'] = uniqid();
	$_SESSION['nickname'] = $newloc['nickname'];

	//Update database	
	if(!isset($locations['locations']))
		$locations['locations'] = array();
	array_push($locations['locations'], $newloc);
	$locationdb[$_GET['id']] = $locations;

	//Update activity log
	AddActivityEvent($record[$nameCol]." Marked",$newloc['nickname']." marked a position for ".$record[$nameCol]." by ".$newloc['source']." on ".htmlspecialchars(date("F j, Y, g:i a",$newloc['timestamp'])),$newloc['nickname'],"details.php?id=".$_GET['id'],$newloc['uuid']);	
?>

				<div class="post">
					<h2 class="title"><a href="#">Thank you for your submission!</a></h2>
					<div class="entry">
					<p><a href="details.php?id=<?php echo $_GET['id'];?>">Continue</a></p>
					</div>
				</div>

<?php
	}

	if($captchaFailed)
	{
?>
				<div class="post">
					<h2 class="title"><a href="#">Captcha Problem</a></h2>
					<div class="entry">
					<p>There was a problem with the anti-spam test. Please try again.</p>
					</div>
				</div>

<?php
	}
}

//*****************
//Form
//*****************

if(!isset($_POST['lat']) or $captchaFailed)
{
if($basemap=="osm") $mapName = "<a href=\"www.openstreetmap.org\">Open Street Map</a>";
if($basemap=="sv") $mapName = "<a href=\"http://www.ordnancesurvey.co.uk/opendata/\">Ordnance Survey Opendata Map (StreetView)</a>";
if($basemap=="os7") $mapName = "<a href=\"http://steve8.dev.openstreetmap.org/os7.htm\">7th Series OS Map</a>";
if($basemap=="npe") $mapName = "<a href=\"http://www.npemap.org.uk/\">New Popular Edition Map (StreetView)</a>";

if(!isset($_SESSION['nickname'])) $_SESSION['nickname'] = "Anonymous";
?>


				<div class="post">
					<h2 class="title">Add a new position on <?php echo $mapName;?> for <?php echo htmlspecialchars($record[$nameCol]);?></h2>
					<div class="entry">
						
						<form method="post" action="" id="form1">
						<p>Click once on the map to select the true position.</p>

						    <div id="map_canvas" style="width: 100%; height: 400px;"></div>

						<p>Your nickname: <input type="text" name="nickname" value="<?php echo $_SESSION['nickname'];?>"/></p>
						<p>Latitude (deg): <input type="text" id="lat" name="lat" value="51.0"/>, Longitude (deg): <input type="text" id="lon" name="lon" value="1.0"/>
						<input type="hidden" id="layer" name="layer" value="<?php echo $basemap;?>"/></p>
						
						<p>Comments: <input type="text" name="comment" value=""/></p>
						<p>Maximum characters: <?php echo $maxchars; ?>. No HTML. You agree to waive any copyright, database right, and any other rights that may be waived, over submitted information, as specified in the <a href="http://creativecommons.org/choose/zero/">CC0 license</a>. This enables others to use your knowledge in innovative ways.</p> 
<?php
if(GetConfigOption('enableCaptcha'))
{
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$publickey = GetConfigOption('recaptchaPublic');
	echo recaptcha_get_html($publickey);
}
?>
						<p><input type="submit" value="Submit" /></p>
						</form>
						<p><a href="details.php?id=<?php echo $_GET['id'];?>">Cancel</a></p>
					</div>
<?php
}

?>

					
				</div>



			</div>
			<!-- end #content -->
			<div id="sidebar">
				<ul>
					<?php require('sidebar.php'); ?>

				</ul>
			</div>
			<!-- end #sidebar -->
			<div style="clear: both;">&nbsp;</div>
		</div>
	</div>
	<!-- end #page -->
	<div id="footer">

<?php
echo GetConfigOption('footer');
?>
	</div>
	<!-- end #footer -->
</div>
</body>
</html>
