<?php
die();
require_once('dbutils.php');
//require_once('latlong.php');
echo 'Initialising OSTN02...';
require_once('ostn02php/OSTN02.php');
echo 'done';
require_once('ostn02php/OSGB.php');
require_once('codepoint/codepoint.php');
require_once('config.php');

$masterdb = new GenericSqliteTable("var/master.db","master");
$locationdb = new GenericSqliteTable("var/locations.db","locations");

$ids = $masterdb->GetKeys();

echo "<ul>\n";

foreach($ids as $id)
{
	$record = $masterdb[$id];
	echo "<li>".htmlspecialchars($record[$nameCol]);
	
	$locations = $locationdb[$id];
	//$latlon = gr_to_wgs84_ll(array ("e"=>$record['Easting'],"n"=>$record['Northing']));


	//Calculate position
	//if(!isset($record['X'])) continue;
	//echo $record['Easting'].",".$record['Northing'];

	$pos = GetCodepointPos($record['POSTCODE']);
	if($pos === null) continue;

	try
	{
		list($x,$y,$h) = OSGB36_to_ETRS89 ($pos[0],$pos[1]);
	}
	catch (Exception $e) {
		echo 'Caught exception: ',  $e->getMessage(), "\n";
		continue;
	}
	
	//list($x,$y,$h) = OSGB36_to_ETRS89 ($record['X'],$record['Y']);
	//echo ",".$x.",".$y;
	list($gla, $glo) = grid_to_ll($x, $y);
	echo ", ".$gla,", ".$glo;
	
	//Remove previous rough location
	//$locations['locations'] = array();
	$templocs = array();
	if(!isset($locations['locations']))
		$locations['locations'] = array();
	foreach ($locations['locations'] as $loc)
	{
		if(!$loc['roughposition'])
		{
			array_push($templocs, $loc);
			echo " keeppos";
		}
	}
	$locations['locations'] = $templocs;

	//Add a new rought location
	{
	$newloc['comment'] = "";
	$newloc['nickname'] = "KCC OpenKent Import";
	$newloc['lat'] = (float)($gla);
	$newloc['lon'] = (float)($glo);
	$newloc['timestamp'] = time();
	$newloc['source'] = "KCC OpenKent/OS Codepoint";
	$newloc['license'] = "OGL/OS OpenData";
	$newloc['roughposition'] = 1;//!($record['Positional Quality of the Grid Reference'] == '1m at address delivery point');
	$newloc['karma'] = 0;
	$newloc['uuid'] = uniqid();
	
	array_push($locations['locations'], $newloc);
	$locationdb[$id] = $locations;
	echo " updated";
	}
	echo "</li>\n";
	
}

echo "</ul>\n";



?>
